/* CamacModules.cc */
/* Edited by Sanshiro E. on 26 May 1997. */
/* Last updated by Sanshiro E. on 16 April 1999. */

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "CamacModules.hh"



TCommonplaceCamacModule::TCommonplaceCamacModule(TCamacParameters& CamacParameters)
: _CamacParameters(CamacParameters)
{
}

TCommonplaceCamacModule::TCommonplaceCamacModule(void)
{
}

TCommonplaceCamacModule::~TCommonplaceCamacModule() 
{
    DisableLam();
}

int TCommonplaceCamacModule::Read(int Channel, int &Data) throw(THardwareException)
{
    return CamacAction(Channel, _CamacParameters.ReadFunction, Data);
}

int TCommonplaceCamacModule::Clear(int Channel) throw(THardwareException)
{
    if (Channel < 0) {
	Channel = 0;
    }
    return CamacAction(Channel, _CamacParameters.ClearFunction);
}

int TCommonplaceCamacModule::HasData(int Channel) throw(THardwareException)
{
    return IsLamRequested();
}

int TCommonplaceCamacModule::WaitData(unsigned TimeOut) throw(THardwareException)
{
    return WaitLam(TimeOut);
}

int TCommonplaceCamacModule::NumberOfChannels(void) throw(THardwareException)
{
    return _CamacParameters.NumberOfChannels;
}

int TCommonplaceCamacModule::NumberOfSamples(void) throw(THardwareException)
{
    return _CamacParameters.NumberOfSamples;
}


TCamacQADC_RPC022::TCamacQADC_RPC022(void)
{
    _CamacParameters.NumberOfChannels = _NumberOfChannels;
    _CamacParameters.NumberOfSamples = _NumberOfSamples;
    _CamacParameters.ReadFunction = fnDataRead;
    _CamacParameters.ClearFunction = fnClear;
}

TCamacQADC_C009::TCamacQADC_C009(void)
{
    _CamacParameters.NumberOfChannels = _NumberOfChannels;
    _CamacParameters.NumberOfSamples = _NumberOfSamples;
    _CamacParameters.ReadFunction = fnDataRead;
    _CamacParameters.ClearFunction = fnClear;
}

TCamacTDC_RPC060::TCamacTDC_RPC060(void)
{
    _CamacParameters.NumberOfChannels = _NumberOfChannels;
    _CamacParameters.NumberOfSamples = _NumberOfSamples;
    _CamacParameters.ReadFunction = fnDataRead;
    _CamacParameters.ClearFunction = fnClear;
}

TCamacTDC_C006::TCamacTDC_C006(void)
{
    _CamacParameters.NumberOfChannels = _NumberOfChannels;
    _CamacParameters.NumberOfSamples = _NumberOfSamples;
    _CamacParameters.ReadFunction = fnDataRead;
    _CamacParameters.ClearFunction = fnClear;
}

TCamacFADC_RPC081::TCamacFADC_RPC081(void)
{
    _CamacParameters.NumberOfChannels = _NumberOfChannels;
    _CamacParameters.NumberOfSamples = _NumberOfSamples;
    _CamacParameters.ReadFunction = fnDataRead;
    _CamacParameters.ClearFunction = fnClear;
}

int TCamacFADC_RPC081::Clear(int Channel) throw(THardwareException)
{
    if (Channel < 0) {
	for (Channel = 0; Channel < _NumberOfChannels; Channel++) {
	    CamacAction(Channel, fnClear);
	}
    }
    else {
	CamacAction(Channel, fnClear);
    }

    return 0;
}
