/* ModuleFactory.hh */
/* Edited by Sanshiro E. on 7 May 1999. */
/* Last updated by Sanshiro E. on 7 May 1999. */

#ifndef __ModuleFactory_hh__
#define __ModuleFactory_hh__

#include <iostream.h>
#include "RoomDefs.hh"
#include "Module.hh"
#include "VmeAccess.hh"
#include "CamacAccess.hh"
#include "SoftwareModules.hh"


class TDeviceFactory {
  public:
    TDeviceFactory();
    virtual ~TDeviceFactory();
    virtual TVmeModule* CreateVmeModule(const char* Name) throw(THardwareException);
    virtual TCamacModule* CreateCamacModule(const char* Name) throw(THardwareException);
    virtual TSoftwareModule* CreateSoftwareModule(const char* Name) throw(THardwareException);
    virtual TVmeCrate* CreateVmeCrate(const char* Name = 0) throw(THardwareException);
    virtual TCamacCrate* CreateCamacCrate(const char* Name = 0) throw(THardwareException);
    virtual TVmeController* CreateVmeController(const char* Name = 0) throw(THardwareException);
    virtual TCamacController* CreateCamacController(const char* Name = 0) throw(THardwareException);
};


#endif
