/* KEK_CC.hh */
/* CAMAC I/O class library for KEK CAMAC driver (cc) */
/* Edited by Sanshiro E. on 23 October 1997. */
/* Last updated by Sanshiro E. on 1 March 1999. */

#ifndef __KEK_CC_hh__
#define __KEK_CC_hh__


#include "CamacAccess.hh" 

class TCamacController_KEKCC: public TCamacController {
  public:
    TCamacController_KEKCC(void) throw(THardwareException);
    virtual ~TCamacController_KEKCC();
    virtual int CamacAction(int StationNumber, int Address, int Function, int &Data, int &Q, int &X) throw(THardwareException);
    virtual int Initialize(void) throw(THardwareException);
    virtual int Clear(void) throw(THardwareException);
    virtual int Inhibit(void) throw(THardwareException);
    virtual int ReleaseInhibit(void) throw(THardwareException);
    virtual int EnableInterrupt(void) throw(THardwareException);
    virtual int DisableInterrupt(void) throw(THardwareException);
    virtual int ReadLam(void) throw(THardwareException);
    virtual int WaitLam(int TimeLimit) throw(THardwareException);
  private:
    int _IsInterruptEnable;
};

#endif
