/* RoomDefs.cc */
/* Edited by Sanshiro E. on 18 November 1997. */
/* Last updated by Sanshiro E. on 18 Febuary 1998. */

#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <signal.h>
#include "RoomDefs.hh"


THardwareException::THardwareException(const char *Location, const char *Message) 
{
    sprintf(_Message, "%s: %s", Location, Message);
}

THardwareException::THardwareException(const THardwareException &e) 
{
    strcpy(_Message, e._Message);
}    

const char *THardwareException::Message(void) const
{
    return _Message;
}

ostream& operator<< (ostream &os, const THardwareException &e) 
{
    return os << e._Message;
}

static void AlarmSignalHandler(int SignalNumber) {}
void Suspend(unsigned long Time_sec, unsigned long Time_usec)
{
    struct itimerval IntervalTimerValue;
    IntervalTimerValue.it_value.tv_sec = Time_sec + (Time_usec / 1000000UL);
    IntervalTimerValue.it_value.tv_usec = Time_usec % 1000000UL;
    IntervalTimerValue.it_interval.tv_sec = 0;
    IntervalTimerValue.it_interval.tv_usec = 0;

    sigset_t EmptySignalSet;
    sigemptyset(&EmptySignalSet);
    struct sigaction SignalAction;
    SignalAction.sa_handler = AlarmSignalHandler;
    SignalAction.sa_mask = EmptySignalSet;
    SignalAction.sa_flags = 0;

    sigaction(SIGALRM, &SignalAction, NULL);
    setitimer(ITIMER_REAL, &IntervalTimerValue, NULL);
    pause();

    return;
}
