/* SoftwareModules.hh */
/* kinoko software modules */
/* Edited by Sanshiro E. on 23 April 1999. */
/* Last updated by Sanshiro E. on 8 May 1999. */

#ifndef __softwaremodules_hh__
#define __softwaremodules_hh__

#include <iostream.h>
#include "RoomDefs.hh"
#include "Module.hh"


class TSoftwareModule: public TModule 
{
  public:
    TSoftwareModule(void) {}
    virtual ~TSoftwareModule() {}    
};


class TPoissonGenerator: public TSoftwareModule {
  public:
    TPoissonGenerator(int NumberOfChannels = 16, int NumberOfSamples = 1, long FullScale = 4096);
    virtual ~TPoissonGenerator();
    virtual int Clear(int Channel = -1) throw(THardwareException);
    virtual int Read(int Channel, int &Data) throw(THardwareException);
    virtual int NumberOfChannels(void) throw(THardwareException);
    virtual int NumberOfSamples(void) throw(THardwareException);
  private:
    int _NumberOfChannels;
    int _NumberOfSamples;
    long _FullScale;
    int *_ReadoutCount;
};


class TSoftwareCounter: public TSoftwareModule {
  public:
    TSoftwareCounter(int NumberOfChannels = 16, int NumberOfSamples = 1, long FullScale = 4096);
    virtual ~TSoftwareCounter();
    virtual int Initialize(int InitialState = 0) throw(THardwareException);
    virtual int Read(int Channel, int &Data) throw(THardwareException);
    virtual int NumberOfChannels(void) throw(THardwareException);
    virtual int NumberOfSamples(void) throw(THardwareException);
  private:
    int _NumberOfChannels;
    int _NumberOfSamples;
    long _FullScale;
    int *_ReadoutCount;
};

#endif

