/* TOYO_CC7700.hh */
/* CAMAC I/O class library for CC/7700 (camdrv) */
/* Edited by Sanshiro E. on 13 April 1999. */
/* Last updated by Sanshiro E. on 13 April 1999. */

#ifndef __TOYO_CC7700_hh__
#define __TOYO_CC7700_hh__


#include "CamacAccess.hh" 

class TCamacController_CC7700: public TCamacController {
  public:
    TCamacController_CC7700(void) throw(THardwareException);
    virtual ~TCamacController_CC7700();
    virtual int CamacAction(int StationNumber, int Address, int Function, int &Data, int &Q, int &X) throw(THardwareException);
    virtual int Initialize(void) throw(THardwareException);
    virtual int Clear(void) throw(THardwareException);
    virtual int Inhibit(void) throw(THardwareException);
    virtual int ReleaseInhibit(void) throw(THardwareException);
    virtual int EnableInterrupt(void) throw(THardwareException);
    virtual int DisableInterrupt(void) throw(THardwareException);
    virtual int ReadLam(void) throw(THardwareException);
    virtual int WaitLam(int TimeOut /* sec */) throw(THardwareException);
  private:
    int _Device;
    int _IsInterruptEnabled;
};

#endif
